# HG changeset patch
# User Valentin Bartenev <vbart@nginx.com>
# Date 1363008869 -14400
# Node ID 0b15bb8b69dfe7c02ab4d56e3be57b8f151481a7
# Parent  dda29f9a2b2a975538da2a2d7870cb0e8a408b80
Gzip: fixed setting of NGX_HTTP_GZIP_BUFFERED.

In r2411 setting of NGX_HTTP_GZIP_BUFFERED in c->buffered was moved from
ngx_http_gzip_filter_deflate_start() to ngx_http_gzip_filter_buffer() since
it was always called first.  But in r2543 the "postpone_gzipping" directive
was introduced, and if postponed gzipping is disabled (the default setting),
ngx_http_gzip_filter_buffer() is not called at all.

We must always set NGX_HTTP_GZIP_BUFFERED after the start of compression
since there is always a trailer that is buffered.

There are no known cases when it leads to any problem with current code.
But we already had troubles in upcoming SPDY implementation.

diff -r dda29f9a2b2a -r 0b15bb8b69df src/http/modules/ngx_http_gzip_filter_module.c
--- a/src/http/modules/ngx_http_gzip_filter_module.c	Mon Mar 11 17:34:29 2013 +0400
+++ b/src/http/modules/ngx_http_gzip_filter_module.c	Mon Mar 11 17:34:29 2013 +0400
@@ -620,6 +620,8 @@ ngx_http_gzip_filter_deflate_start(ngx_h
         return NGX_ERROR;
     }
 
+    r->connection->buffered |= NGX_HTTP_GZIP_BUFFERED;
+
     ctx->last_out = &ctx->out;
     ctx->crc32 = crc32(0L, Z_NULL, 0);
     ctx->flush = Z_NO_FLUSH;
